Ruby - Feature #12333

‘String#concat’, 'Array#concat’, String#prepend’ to take multiple arguments

04/30/2016 12:25 PM - sawa (Tsuyoshi Sawada)

Status: Closed
Priority: Normal
Assignee:

Target version:

Description
I would like String#concat, Array#concat, String#prepend to take multiple arguments

—_ nn
'concat(lla", llbll, Ilcll)
.prepend("A"’ "B", llcll)
# => "ABCabc"

n 9 n n

a =[]
a.concat (["a"1, ["b", "c"1)
a # => ["a", "b", "C"}

Related issues:
Related to Ruby - Feature #12247: accept multiple arguments at Array#delete Open

Related to Ruby - Bug #13268: [DOC] Restore docs for String#<< Closed

Associated revisions

Revision 93871f7315b498a6e7c8ab2adb1582fd6¢c717524 - 08/27/2016 01:26 AM - nobu (Nobuyoshi Nakada)

multiple arguments
e array.c (rb_ary_concat_multi): take multiple arguments. based
on the patch by Satoru Horie. [Feature #12333]
e string.c (rb_str_concat_multi, rb_str_prepend_multi): ditto.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56021 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 93871f73 - 08/27/2016 01:26 AM - nobu (Nobuyoshi Nakada)
multiple arguments
e array.c (rb_ary_concat_multi): take multiple arguments. based
on the patch by Satoru Horie. [Feature #12333]

e string.c (rb_str_concat_multi, rb_str_prepend_multi): ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56021 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/02/2016 01:45 AM - duerst (Martin Diirst)

I think this can occasionally be helpful, and shouldn't be too difficult to implement. Can you provide a patch?

#2 - 05/02/2016 03:25 AM - spinute (Satoru Horie)

I will try to write a patch for it!

#3 - 05/03/2016 07:15 AM - spinute (Satoru Horie)
- File multi_concat_prepend.patch added
| have written a patch.
And, there are some points to ask
e What is the appropriate behavior when calling concat/prepend without argument?

¢ The code attached now returns just self
What should happen when writing ar.concat(ar, ar)?

e ar = [1]; ar.concat(ar, ar) #=>[1,1,1]? or [1,1,1,1]?

e ar << ar << ar returns [1,1,1,1], of course because this is just a sequence of binary operations

e However, | feel "ar.concat(ar, ar)" saying "append present content of the array twice to the array", meaning [1,1,1]

¢ The code attached returns [1,1,1,1], for now, just for the simplicity of implementation

#4 - 05/03/2016 08:08 AM - spinute (Satoru Horie)

- File fixed_multi_concat_prepend.patch added

| wrote another patch refined for a problem stated in a previous post.
It behaves like below

ar = [1]
ar.concat (ar, ar) #=> [1,1,1]

str = "ab"
str.concat (str, str) #=> "ababab"

#5 - 05/03/2016 08:23 AM - sawa (Tsuyoshi Sawada)
Satoru, thank you for the patch.
And you are making good points with the questions you raised.
e What is the appropriate behavior when calling concat/prepend without argument?
¢ The code attached now returns just self
| agree with this behavior. | think this would be the most natural.
e What should happen when writing ar.concat(ar, ar)?
e ar = [1]; ar.concat(ar, ar) #=>[1,1,1]? or [1,1,1,1]?
e ar << ar << ar returns [1,1,1,1], of course because this is just a sequence of binary operations
This is more logical (in some sense), but counter-intuitive.

e However, | feel "ar.concat(ar, ar)" saying "append present content of the array twice to the array", meaning [1,1,1]

This is more intuitive, but may be less logical.
| have preference with the second option, but am not completely sure. Maybe other people might have different opinions.

#6 - 05/28/2016 04:40 AM - hsbt (Hiroshi SHIBATA)
- Related to Feature #12247: accept multiple arguments at Array#delete added

#7 - 06/13/2016 06:46 AM - matz (Yukihiro Matsumoto)
Approved. | want to

ar = [1]
ar.concat (ar, ar)

to result [1,1,1].

Matz.

#8 - 06/20/2016 03:32 PM - spinute (Satoru Horie)
- File multi_concat_prepend.patch added

| added some test cases for Array#concat, String#concat and String#prepend and refined error handling.
Also, | fixed my code to conform to convention.
Any feedback is welcome!

#9 - 08/27/2016 01:26 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset r56021.

multiple arguments

e array.c (rb_ary_concat_multi): take multiple arguments. based
on the patch by Satoru Horie. [Feature #12333]
e string.c (rb_str_concat_multi, rb_str_prepend_multi): ditto.

#10 - 03/02/2017 10:23 AM - stomar (Marcus Stollsteimer)
- Related to Bug #13268: [DOC] Restore docs for String#<< added

Files

multi_concat_prepend.patch 2.94 KB 05/03/2016 spinute (Satoru Horie)

fixed_multi_concat_prepend.patch 3.14 KB 05/03/2016 spinute (Satoru Horie)

multi_concat_prepend.patch 7.19 KB 06/20/2016 spinute (Satoru Horie)
